unit UMainForm;

{$mode Delphi}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, SynEdit, Forms, Controls, Graphics, Dialogs,
  Menus, ActnList, StdCtrls, ComCtrls, UBrainFuck;

type

  { TMainForm }

  TMainForm = class(TForm)
    ACompile: TAction;
    AAbout: TAction;
    AHelp: TAction;
    ARun: TAction;
    AProjectNew: TAction;
    AExit: TAction;
    AProjectSaveAs: TAction;
    AProjectClose: TAction;
    AProjectSave: TAction;
    AProjectOpen: TAction;
    ActionList1: TActionList;
    ImageList1: TImageList;
    MainMenu1: TMainMenu;
    MemoSource: TMemo;
    MenuItem1: TMenuItem;
    MenuItem10: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem12: TMenuItem;
    MenuItem13: TMenuItem;
    MenuItem14: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    StatusBar1: TStatusBar;
    TabControl1: TTabControl;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    procedure AExitExecute(Sender: TObject);
    procedure ARunExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { private declarations }
  public
    BrainFuckInterpreter: TBrainFuckInterpreter;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.lfm}

uses
  UInterpreterForm;

{ TMainForm }

procedure TMainForm.FormShow(Sender: TObject);
begin

end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  BrainFuckInterpreter := TBrainFuckInterpreter.Create;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  BrainFuckInterpreter.Free;
end;

procedure TMainForm.ARunExecute(Sender: TObject);
begin
  InterpreterForm.Show;
  BrainFuckInterpreter.Input := InterpreterForm.MemoInput.Lines.Text;
  BrainFuckInterpreter.Source := MemoSource.Lines.Text;
  BrainFuckInterpreter.Run;
  InterpreterForm.MemoOutput.Lines.Text := BrainFuckInterpreter.Output;
end;

procedure TMainForm.AExitExecute(Sender: TObject);
begin
  Close;
end;

end.

